#define _GNU_SOURCE 1
#include <stdlib.h>
#include <string.h>
#include <link.h>
#include <sys/stat.h>

extern unsigned int la_version (unsigned int __version)
{
  return LAV_CURRENT;
}
char *
la_objsearch (const char *name, uintptr_t *cookie, unsigned int flag)
{
  char buf[100];
  const char *flagstr;
  char *framework_paths = getenv("GS_FRAMEWORK_PATH");
  struct stat junk;

  if (framework_paths == NULL)
    return (char *)name;

  if (flag == LA_SER_ORIG && name[0] == '$')
    if (strcmp(name, "$FRAMEWORK/") > 0)
      {
	
	char *framework_path;
	
        while ((framework_path = strsep(&framework_paths, ":")))
	  {
 	    char * ret = (char *)malloc(strlen(framework_path)
			    		+ sizeof('/')
		 		        + strlen(&name[11])
					+ sizeof('\0'));
	    
	    sprintf(ret, "%s%s%s",framework_path, "/", &name[11]);
            if (stat(ret, &junk) == 0)
	      {
		return (char *)ret;
	      }
	  }
       }
  return (char *) name;
}

